package fr.uca.iut.clfreville2.model.sensor.auto;

import fr.uca.iut.clfreville2.model.sensor.AutoSensor;

import java.util.Random;

public class RandomVariationStrategy implements AutoUpdateStrategy {

    private final Random random;
    private final int maxVariation;

    public RandomVariationStrategy(int maxVariation) {
        this(new Random(), maxVariation);
    }

    public RandomVariationStrategy(Random random, int maxVariation) {
        this.random = random;
        this.maxVariation = maxVariation;
    }

    @Override
    public double nextValue(AutoSensor currentState) {
        return currentState.getTemperature() + random.nextInt(maxVariation * 2) - maxVariation;
    }
}
